Index: trunk/src/VBox/ValidationKit/tests/storage/remoteexecutor.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/storage/remoteexecutor.py	(revision 64787)
+++ trunk/src/VBox/ValidationKit/tests/storage/remoteexecutor.py	(revision 64847)
@@ -139,5 +139,5 @@
         return (True, str(sOutput));
 
-    def _execLocallyOrThroughTxs(self, sExec, asArgs, sInput):
+    def _execLocallyOrThroughTxs(self, sExec, asArgs, sInput, cMsTimeout):
         """
         Executes the given program locally or through TXS based on the
@@ -154,5 +154,6 @@
                 oStdIn = '/dev/null'; # pylint: disable=R0204
             fRc = self.oTxsSession.syncExecEx(sExec, (sExec,) + asArgs,
-                                              oStdIn = oStdIn, oStdOut = oStdOut);
+                                              oStdIn = oStdIn, oStdOut = oStdOut,
+                                              cMsTimeout = cMsTimeout);
             sOutput = oStdOut.getOutput();
         else:
@@ -160,5 +161,5 @@
         return (fRc, sOutput);
 
-    def execBinary(self, sExec, asArgs, sInput = None):
+    def execBinary(self, sExec, asArgs, sInput = None, cMsTimeout = 3600000):
         """
         Executes the given binary with the given arguments
@@ -172,5 +173,5 @@
         sBinary = self._getBinaryPath(sExec);
         if sBinary is not None:
-            fRc, sOutput = self._execLocallyOrThroughTxs(sBinary, asArgs, sInput);
+            fRc, sOutput = self._execLocallyOrThroughTxs(sBinary, asArgs, sInput, cMsTimeout);
         else:
             fRc = False;
Index: trunk/src/VBox/ValidationKit/tests/storage/storagecfg.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/storage/storagecfg.py	(revision 64787)
+++ trunk/src/VBox/ValidationKit/tests/storage/storagecfg.py	(revision 64847)
@@ -392,9 +392,9 @@
 
         # Destroy all volumes first.
-        for sMountPoint in self.dVols.keys():
+        for sMountPoint in self.dVols.keys(): # pylint: disable=C0201
             self.destroyVolume(sMountPoint);
 
         # Destroy all pools.
-        for sPool in self.dPools.keys():
+        for sPool in self.dPools.keys(): # pylint: disable=C0201
             self.destroyStoragePool(sPool);
 
Index: trunk/src/VBox/ValidationKit/tests/storage/tdStorageBenchmark1.py
===================================================================
--- trunk/src/VBox/ValidationKit/tests/storage/tdStorageBenchmark1.py	(revision 64787)
+++ trunk/src/VBox/ValidationKit/tests/storage/tdStorageBenchmark1.py	(revision 64847)
@@ -127,5 +127,5 @@
         """ Runs the testcase """
         _ = cMsTimeout
-        fRc, sOutput = self.oExecutor.execBinary('fio', (self.sCfgFileId,));
+        fRc, sOutput = self.oExecutor.execBinary('fio', (self.sCfgFileId,), cMsTimeout = cMsTimeout);
         # @todo: Parse output.
         _ = sOutput;
@@ -182,5 +182,5 @@
         if self.fDirectIo:
             tupArgs += ('-I',);
-        fRc, sOutput = self.oExecutor.execBinary('iozone', tupArgs);
+        fRc, sOutput = self.oExecutor.execBinary('iozone', tupArgs, cMsTimeout = cMsTimeout);
         if fRc:
             self.sResult = sOutput;
@@ -835,5 +835,6 @@
         return self.kdHostIoCacheDescs[sHostIoCache];
 
-    def testBenchmark(self, sTargetOs, sBenchmark, sMountpoint, oExecutor, dTestSet):
+    def testBenchmark(self, sTargetOs, sBenchmark, sMountpoint, oExecutor, dTestSet, \
+                      cMsTimeout = 3600000):
         """
         Runs the given benchmark on the test host.
@@ -852,5 +853,5 @@
             fRc = oTst.prepare();
             if fRc:
-                fRc = oTst.run();
+                fRc = oTst.run(cMsTimeout);
                 if fRc:
                     if self.fReportBenchmarkResults:
@@ -1009,5 +1010,6 @@
                     sMountPoint = self.prepareStorage(oStorCfgVm);
                     if sMountPoint is not None:
-                        self.testBenchmark('linux', sIoTest, sMountPoint, oExecVm, dTestSet);
+                        self.testBenchmark('linux', sIoTest, sMountPoint, oExecVm, dTestSet, \
+                                           cMsTimeout = 2 * 3600 * 1000); # 2 hours max (Benchmark and QCOW takes some time)
                         self.cleanupStorage(oStorCfgVm);
                     else: